Index: uspace/lib/net/generic/generic.c
===================================================================
--- uspace/lib/net/generic/generic.c	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/lib/net/generic/generic.c	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -100,5 +100,5 @@
 int
 generic_get_addr_req(int phone, int message, device_id_t device_id,
-    measured_string_t **address, char ** data)
+    measured_string_t **address, uint8_t **data)
 {
 	aid_t message_id;
@@ -112,5 +112,5 @@
 	message_id = async_send_1(phone, (sysarg_t) message,
 	    (sysarg_t) device_id, NULL);
-	string = measured_strings_return(phone, address, data, 1);
+	string = measured_strings_return(phone, address, (char **) data, 1);
 	async_wait_for(message_id, &result);
 
Index: uspace/lib/net/include/generic.h
===================================================================
--- uspace/lib/net/include/generic.h	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/lib/net/include/generic.h	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -50,5 +50,5 @@
 extern int generic_device_req_remote(int, int, device_id_t, int, services_t);
 extern int generic_get_addr_req(int, int, device_id_t, measured_string_t **,
-    char **);
+    uint8_t **);
 extern int generic_packet_size_req_remote(int, int, device_id_t,
     packet_dimension_t *);
Index: uspace/lib/net/include/netif_local.h
===================================================================
--- uspace/lib/net/include/netif_local.h	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/lib/net/include/netif_local.h	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -196,5 +196,5 @@
 
 extern int netif_get_addr_req_local(int, device_id_t, measured_string_t **,
-    char **);
+    uint8_t **);
 extern int netif_probe_req_local(int, device_id_t, int, int);
 extern int netif_send_msg_local(int, device_id_t, packet_t *, services_t);
Index: uspace/lib/net/include/netif_remote.h
===================================================================
--- uspace/lib/net/include/netif_remote.h	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/lib/net/include/netif_remote.h	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -42,5 +42,5 @@
 
 extern int netif_get_addr_req_remote(int, device_id_t, measured_string_t **,
-    char **);
+    uint8_t **);
 extern int netif_probe_req_remote(int, device_id_t, int, int);
 extern int netif_send_msg_remote(int, device_id_t, packet_t *, services_t);
Index: uspace/lib/net/netif/netif_local.c
===================================================================
--- uspace/lib/net/netif/netif_local.c	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/lib/net/netif/netif_local.c	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -203,5 +203,5 @@
  */
 int netif_get_addr_req_local(int netif_phone, device_id_t device_id,
-    measured_string_t **address, char **data)
+    measured_string_t **address, uint8_t **data)
 {
 	int rc;
@@ -221,5 +221,5 @@
 	fibril_rwlock_read_unlock(&netif_globals.lock);
 	
-	*data = (**address).value;
+	*data = (uint8_t *) (**address).value;
 	
 	return rc;
Index: uspace/lib/net/netif/netif_remote.c
===================================================================
--- uspace/lib/net/netif/netif_remote.c	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/lib/net/netif/netif_remote.c	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -60,5 +60,5 @@
  */
 int netif_get_addr_req_remote(int netif_phone, device_id_t device_id,
-    measured_string_t **address, char **data)
+    measured_string_t **address, uint8_t **data)
 {
 	return generic_get_addr_req(netif_phone, NET_NETIF_GET_ADDR, device_id,
Index: uspace/srv/hw/netif/dp8390/dp8390.c
===================================================================
--- uspace/srv/hw/netif/dp8390/dp8390.c	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/srv/hw/netif/dp8390/dp8390.c	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -263,5 +263,5 @@
 	printf("Ethernet address ");
 	for (i = 0; i < 6; i++)
-		printf("%x%c", dep->de_address.ea_addr[i], i < 5 ? ':' : '\n');
+		printf("%02x%c", dep->de_address.ea_addr[i], i < 5 ? ':' : '\n');
 	
 	/*
Index: uspace/srv/net/il/arp/arp.c
===================================================================
--- uspace/srv/net/il/arp/arp.c	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/srv/net/il/arp/arp.c	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -215,5 +215,5 @@
 	(*proto)->service = service;
 	(*proto)->addr = address;
-	(*proto)->addr_data = address->value;
+	(*proto)->addr_data = (uint8_t *) address->value;
 	
 	rc = arp_addr_initialize(&(*proto)->addresses);
@@ -267,5 +267,5 @@
 			free(proto->addr_data);
 			proto->addr = address;
-			proto->addr_data = address->value;
+			proto->addr_data = (uint8_t *) address->value;
 		} else {
 			rc = arp_proto_create(&proto, protocol, address);
Index: uspace/srv/net/il/arp/arp.h
===================================================================
--- uspace/srv/net/il/arp/arp.h	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/srv/net/il/arp/arp.h	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -96,9 +96,9 @@
 	measured_string_t *addr;
 	/** Actual device hardware address data. */
-	char *addr_data;
+	uint8_t *addr_data;
 	/** Broadcast device hardware address. */
 	measured_string_t *broadcast_addr;
 	/** Broadcast device hardware address data. */
-	char *broadcast_data;
+	uint8_t *broadcast_data;
 	/** Device identifier. */
 	device_id_t device_id;
@@ -142,5 +142,5 @@
 	measured_string_t *addr;
 	/** Actual device protocol address data. */
-	char *addr_data;
+	uint8_t *addr_data;
 	/** Address map. */
 	arp_addr_t addresses;
@@ -154,5 +154,5 @@
 	 * Hardware address for the translation. NULL denotes an incomplete
 	 * record with possible waiters.
-	 */ 
+	 */
 	measured_string_t *hw_addr;
 	/** Condition variable used for waiting for completion of the record. */
Index: uspace/srv/net/nil/eth/eth.c
===================================================================
--- uspace/srv/net/nil/eth/eth.c	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/srv/net/nil/eth/eth.c	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -407,5 +407,5 @@
 	
 	printf("%s: Device registered (id: %d, service: %d: mtu: %zu, "
-	    "mac: %x:%x:%x:%x:%x:%x, flags: 0x%x)\n",
+	    "mac: %02x:%02x:%02x:%02x:%02x:%02x, flags: 0x%x)\n",
 	    NAME, device->device_id, device->service, device->mtu,
 	    device->addr_data[0], device->addr_data[1],
Index: uspace/srv/net/nil/eth/eth.h
===================================================================
--- uspace/srv/net/nil/eth/eth.h	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/srv/net/nil/eth/eth.h	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -91,6 +91,7 @@
 	/** Actual device hardware address. */
 	measured_string_t *addr;
+	
 	/** Actual device hardware address data. */
-	char *addr_data;
+	uint8_t *addr_data;
 };
 
Index: uspace/srv/net/nil/nildummy/nildummy.h
===================================================================
--- uspace/srv/net/nil/nildummy/nildummy.h	(revision 7922deace1d89dc46969ce07718407c0c2fca1d8)
+++ uspace/srv/net/nil/nildummy/nildummy.h	(revision 854151c609055c16544a89e14572ba81716e8683)
@@ -78,5 +78,5 @@
 	measured_string_t *addr;
 	/** Actual device hardware address data. */
-	char *addr_data;
+	uint8_t *addr_data;
 };
 