Index: arch/amd64/Makefile.inc
===================================================================
--- arch/amd64/Makefile.inc	(revision a6d4cebe4e2af4fd70f49dc2ffb18186d4447b4a)
+++ arch/amd64/Makefile.inc	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -104,4 +104,5 @@
 	arch/$(ARCH)/src/cpu/cpu.c \
 	arch/$(ARCH)/src/proc/scheduler.c \
+	arch/$(ARCH)/src/proc/task.c \
 	arch/$(ARCH)/src/proc/thread.c \
 	arch/$(ARCH)/src/userspace.c \
Index: arch/amd64/src/proc/task.c
===================================================================
--- arch/amd64/src/proc/task.c	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
+++ arch/amd64/src/proc/task.c	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -0,0 +1,40 @@
+/*
+ * Copyright (C) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <proc/task.h>
+#include <arch/types.h>
+
+/** Perform amd64 specific task initialization.
+ *
+ * @param t Task to be initialized.
+ */
+void task_create_arch(task_t *t)
+{
+	t->arch.iomap = NULL;
+	t->arch.iomap_size = 0;
+}
Index: arch/ia32/Makefile.inc
===================================================================
--- arch/ia32/Makefile.inc	(revision a6d4cebe4e2af4fd70f49dc2ffb18186d4447b4a)
+++ arch/ia32/Makefile.inc	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -109,4 +109,5 @@
 	arch/$(ARCH)/src/asm.S \
 	arch/$(ARCH)/src/proc/scheduler.c \
+	arch/$(ARCH)/src/proc/task.c \
 	arch/$(ARCH)/src/proc/thread.c \
 	arch/$(ARCH)/src/bios/bios.c \
Index: arch/ia32/src/proc/task.c
===================================================================
--- arch/ia32/src/proc/task.c	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
+++ arch/ia32/src/proc/task.c	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -0,0 +1,40 @@
+/*
+ * Copyright (C) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <proc/task.h>
+#include <arch/types.h>
+
+/** Perform ia32 specific task initialization.
+ *
+ * @param t Task to be initialized.
+ */
+void task_create_arch(task_t *t)
+{
+	t->arch.iomap = NULL;
+	t->arch.iomap_size = 0;
+}
Index: arch/ia64/include/proc/task.h
===================================================================
--- arch/ia64/include/proc/task.h	(revision a6d4cebe4e2af4fd70f49dc2ffb18186d4447b4a)
+++ arch/ia64/include/proc/task.h	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -33,3 +33,5 @@
 } task_arch_t;
 
+#define task_create_arch(t)
+
 #endif
Index: arch/mips32/include/proc/task.h
===================================================================
--- arch/mips32/include/proc/task.h	(revision a6d4cebe4e2af4fd70f49dc2ffb18186d4447b4a)
+++ arch/mips32/include/proc/task.h	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -33,3 +33,5 @@
 } task_arch_t;
 
+#define task_create_arch(t)
+
 #endif
Index: arch/ppc32/include/proc/task.h
===================================================================
--- arch/ppc32/include/proc/task.h	(revision a6d4cebe4e2af4fd70f49dc2ffb18186d4447b4a)
+++ arch/ppc32/include/proc/task.h	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -33,3 +33,5 @@
 } task_arch_t;
 
+#define task_create_arch(t)
+
 #endif
Index: arch/ppc64/include/proc/task.h
===================================================================
--- arch/ppc64/include/proc/task.h	(revision a6d4cebe4e2af4fd70f49dc2ffb18186d4447b4a)
+++ arch/ppc64/include/proc/task.h	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -33,3 +33,5 @@
 } task_arch_t;
 
+#define task_create_arch(t)
+
 #endif
Index: arch/sparc64/include/proc/task.h
===================================================================
--- arch/sparc64/include/proc/task.h	(revision a6d4cebe4e2af4fd70f49dc2ffb18186d4447b4a)
+++ arch/sparc64/include/proc/task.h	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -33,3 +33,5 @@
 } task_arch_t;
 
+#define task_create_arch(t)
+
 #endif
Index: generic/include/proc/task.h
===================================================================
--- generic/include/proc/task.h	(revision a6d4cebe4e2af4fd70f49dc2ffb18186d4447b4a)
+++ generic/include/proc/task.h	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -64,4 +64,8 @@
 extern task_t *task_find_by_id(task_id_t id);
 
+#ifndef task_create_arch
+extern void task_create_arch(task_t *t);
+#endif
+
 extern __native sys_get_task_id(task_id_t *uspace_task_id);
 
Index: generic/src/proc/task.c
===================================================================
--- generic/src/proc/task.c	(revision a6d4cebe4e2af4fd70f49dc2ffb18186d4447b4a)
+++ generic/src/proc/task.c	(revision 963074b3ec6ea15686d0e384d696e199e2b7741b)
@@ -83,4 +83,6 @@
 	ta = (task_t *) malloc(sizeof(task_t), 0);
 
+	task_create_arch(ta);
+
 	spinlock_initialize(&ta->lock, "task_ta_lock");
 	list_initialize(&ta->th_head);